# std::basic_string::begin, std::basic_string::cbegin

From cppreference.com
< cpp‎ | string‎ | basic string

iterator begin(); |  |
const_iterator begin() const; |  |
const_iterator cbegin() const; |  | (since C++11)

Returns an iterator to the first character of the string.

`begin()` returns a mutable or constant iterator, depending on the constness of *this.

`cbegin()` always returns a constant iterator. It is equivalent to const_cast<const basic_string&>(*this).begin().

### Parameters

(none)

### Return value

iterator to the first character

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

### Complexity

Constant

### Example

Run this code

    #include <string>
    #include <iostream>

    int main()
    {
        std::string s("Exemplar");
        *s.begin() = 'e';
        std::cout << s <<'\n';

        auto i = s.cbegin();
        std::cout << *i << '\n';
    //  *i = 'E'; // error: i is a constant iterator
    }

Output:

    exemplar
    e

### See also

end cend (C++11) | returns an iterator to the end (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/begin&oldid=91638"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template